## libsdl2 2.26.5+dfsg

=== debian/changelog ===
libsdl2 (2.26.5+dfsg-1pureos2) crimson; urgency=medium

  * d/patches: Fix for OSK popping up on window focus

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Thu, 11 Dec 2025 00:24:16 +0100

libsdl2 (2.26.5+dfsg-1pureos1) crimson; urgency=medium

  * Sync with Debian bookworm
  * Remaining PureOS changes:
    - video: Prefer Wayland backend over X11 on arm64

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Thu, 22 Jun 2023 10:31:48 +0200

libsdl2 (2.0.16+dfsg1-4pureos1) byzantium; urgency=medium

  [ Simon McVittie ]
  * Replace patch with the version that went upstream
  * Enable libdecor on Linux

  [ Sebastian Krzyszkowiak ]
  * Sync with Debian
  * Remaining PureOS patches:
    - Prefer Wayland over X11
    - Enable libdecor on Linux

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Sat, 25 Sep 2021 17:31:48 +0200

libsdl2 (2.0.16+dfsg1-3pureos1) byzantium; urgency=medium

  * d/patches: Drop patches applied upstream
  * Revert "Enable Pipewire audio driver"
  * d/patches: Prefer Wayland over X11 only on arm64
  * Remaining PureOS patches:
    - Prefer Wayland over X11

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Sat, 04 Sep 2021 04:54:24 +0200

libsdl2 (2.0.14+dfsg2-3pureos1) byzantium; urgency=medium

  * Revert "debian: enable touchscreen support with libts"
    Not needed in 2.0.14. See fb9cc959d6e046f0041ccc79082089df7a2b613a.
    This reverts commit 58c80f800464eea473455474b3c713ec7e46cbdc.
  * Replace wayland patches by c-p'ed versions from upstream
  * Rediff patches.  Let's get rid off diff noise so exported patch series can
    be applied without having to worry about anything.
  * Backport kmsdrm changes. This unbreaks mxsfb (Closes: #1)
  * Don't try async page flips when unsupported.
    Fix by Clayton Craft that is not yet applied upstream.
    See https://bugzilla.libsdl.org/show_bug.cgi?id=5518
  * Switch CI to byzantium

 -- Guido Günther <agx@sigxcpu.org>  Fri, 12 Feb 2021 17:02:02 +0100

libsdl2 (2.0.12+dfsg1-5pureos+librem5.2) amber-phone; urgency=high

  * d/patches: Don't crash when the properties of already existing wl_output change

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Thu, 12 Nov 2020 05:32:49 +0100

libsdl2 (2.0.12+dfsg1-5pureos+librem5.1) amber-phone; urgency=medium

  [ Sebastian Krzyszkowiak ]
  * Sync with Debian Bullseye
  * Remove "quit app when compositor quits" patch - it's already in 2.0.12

  [ Clayton Craft ]
  * debian: enable touchscreen support with libts

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Fri, 09 Oct 2020 20:13:09 +0200

libsdl2 (2.0.10+dfsg1-1pureos+librem5.3) amber-phone; urgency=medium

  * wayland: Fix transform and scale handling when setting display mode
  * Backport upstream patch to quit when the compositor quits

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Sun, 16 Aug 2020 17:32:25 +0200

libsdl2 (2.0.10+dfsg1-1pureos+librem5.2) amber-phone; urgency=medium

  * Prefer Wayland backend over X11

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Mon, 23 Sep 2019 01:32:55 +0200

libsdl2 (2.0.10+dfsg1-1pureos+librem5.1) amber-phone; urgency=medium

  * Upload to amber-phone

 -- Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>  Sun, 22 Sep 2019 15:09:12 +0200

=== debian/control ===
Source: libsdl2
Priority: optional
Section: libs
Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders:
 Manuel A. Fernandez Montecelo <mafm@debian.org>,
 Felix Geyer <fgeyer@debian.org>,
 Simon McVittie <smcv@debian.org>
Standards-Version: 4.6.1
Build-Depends:
 debhelper-compat (= 13),
 fcitx-libs-dev,
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libdecor-0-dev [linux-any],
 libdrm-dev [linux-any],
 libegl-dev [!hurd-any],
 libgbm-dev [linux-any],
 libgl-dev,
 libgles-dev [!hurd-any],
 libibus-1.0-dev,
 libpulse-dev,
 libsamplerate0-dev,
 libsndio-dev,
 libudev-dev [linux-any],
 libusb2-dev [kfreebsd-any],
 libusbhid-dev [kfreebsd-any],
 libvulkan-dev [linux-any],
 libwayland-dev (>= 1.18) [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxfixes-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev (>= 0.5.0),
 libxrandr-dev,
 libxss-dev,
 libxt-dev,
 libxv-dev,
 libxxf86vm-dev,
 pkg-config,
 wayland-protocols
Build-Depends-Indep:
 graphviz <!nodoc>,
 doxygen <!nodoc>,
Vcs-Git: https://salsa.debian.org/sdl-team/libsdl2.git
Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl2
Homepage: https://www.libsdl.org/
Rules-Requires-Root: no

Package: libsdl2-2.0-0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 xdg-utils,
Conflicts:
 libsdl-1.3-0
Replaces:
 libsdl-1.3-0
Description: Simple DirectMedia Layer
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This version of SDL is compiled with X11 and Wayland graphics drivers and OSS,
 ALSA, sndio and PulseAudio sound drivers.

Package: libsdl2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libdecor-0-dev [linux-any],
 libdrm-dev [linux-any],
 libegl-dev [!hurd-any],
 libgbm-dev [linux-any],
 libgl-dev,
 libgles-dev [!hurd-any],
 libibus-1.0-dev,
 libpulse-dev,
 libsamplerate0-dev,
 libsdl2-2.0-0 (= ${binary:Version}),
 libsndio-dev,
 libudev-dev [linux-any],
 libusb2-dev [kfreebsd-any],
 libusbhid-dev [kfreebsd-any],
 libwayland-dev [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxfixes-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 libxss-dev,
 libxt-dev,
 libxv-dev,
 libxxf86vm-dev,
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts:
 libsdl-1.3-dev
Replaces:
 libsdl-1.3-dev
Description: Simple DirectMedia Layer development files
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This package contains the files needed to compile and link programs which
 use SDL.

Package: libsdl2-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
Breaks:
 libsdl2-dev (<< 2.0.4+dfsg-1)
Replaces:
 libsdl2-dev (<< 2.0.4+dfsg-1)
Description: Reference manual for libsdl2
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This package contains the reference manual and examples.

Package: libsdl2-tests
Section: misc
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 gnome-desktop-testing
Breaks:
 libsdl2-dev (<< 2.0.22+dfsg-2~)
Replaces:
 libsdl2-dev (<< 2.0.22+dfsg-2~)
Description: Simple DirectMedia Layer automated and manual tests
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This package contains manual and automated tests. The automated tests can
 be run using ginsttest-runner in the gnome-desktop-testing package,
 or manually.

## libsdl2 2.28.2+dfsg

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(SDL2_test)

include(CheckCCompilerFlag)
include(CMakeParseArguments)
include(CMakePushCheckState)

set(SDL_TEST_EXECUTABLES)
set(SDL_TESTS_NONINTERACTIVE)
set(SDL_TESTS_NEEDS_ESOURCES)

macro(add_sdl_test_executable TARGET)
    cmake_parse_arguments(AST "NONINTERACTIVE;NEEDS_RESOURCES" "" "" ${ARGN})
    add_executable(${TARGET} ${AST_UNPARSED_ARGUMENTS})

    list(APPEND SDL_TEST_EXECUTABLES ${TARGET})
    if(AST_NONINTERACTIVE)
        list(APPEND SDL_TESTS_NONINTERACTIVE ${TARGET})
    endif()
    if(AST_NEEDS_RESOURCES)
        list(APPEND SDL_TESTS_NEEDS_ESOURCES ${TARGET})
    endif()
endmacro()

if(NOT TARGET SDL2::SDL2-static)
    find_package(SDL2 2.0.23 REQUIRED COMPONENTS SDL2-static SDL2test)
endif()

enable_testing()

if(SDL_INSTALL_TESTS)
    include(GNUInstallDirs)
endif()

if(N3DS)
    link_libraries(SDL2::SDL2main)
endif()

if(PSP)
    link_libraries(
        SDL2::SDL2main
        SDL2::SDL2test
        SDL2::SDL2-static
        GL
        pspvram
        pspvfpu
        pspdisplay
        pspgu
        pspge
        pspaudio
        pspctrl
        psphprm
        psppower
    )
elseif(PS2)
link_libraries(
        SDL2main
        SDL2_test
        SDL2-static
        patches
        gskit
        dmakit
        ps2_drivers
)
else()
    link_libraries(SDL2::SDL2test SDL2::SDL2-static)
endif()

if(WINDOWS)
    # mingw32 must come before SDL2main to link successfully
    if(MINGW OR CYGWIN)
        link_libraries(mingw32)
    endif()

    # CET support was added in VS 16.7
    if(MSVC_VERSION GREATER 1926 AND CMAKE_GENERATOR_PLATFORM MATCHES "Win32|x64")
        link_libraries(-CETCOMPAT)
    endif()

    # FIXME: Parent directory CMakeLists.txt only sets these for mingw/cygwin,
    # but we need them for VS as well.
    link_libraries(SDL2main)
    add_definitions(-Dmain=SDL_main)
endif()

# CMake incorrectly detects opengl32.lib being present on MSVC ARM64
if(NOT MSVC OR NOT CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64")
    # Prefer GLVND, if present
    set(OpenGL_GL_PREFERENCE GLVND)
    find_package(OpenGL)
endif()

if (OPENGL_FOUND)
add_definitions(-DHAVE_OPENGL)
endif()

add_sdl_test_executable(checkkeys checkkeys.c)
add_sdl_test_executable(checkkeysthreads checkkeysthreads.c)
add_sdl_test_executable(loopwave NEEDS_RESOURCES loopwave.c testutils.c)
add_sdl_test_executable(loopwavequeue NEEDS_RESOURCES loopwavequeue.c testutils.c)
add_sdl_test_executable(testsurround testsurround.c)
add_sdl_test_executable(testresample NEEDS_RESOURCES testresample.c)
add_sdl_test_executable(testaudioinfo testaudioinfo.c)

file(GLOB TESTAUTOMATION_SOURCE_FILES testautomation*.c)
add_sdl_test_executable(testautomation NEEDS_RESOURCES ${TESTAUTOMATION_SOURCE_FILES})
add_sdl_test_executable(testmultiaudio NEEDS_RESOURCES testmultiaudio.c testutils.c)
add_sdl_test_executable(testaudiohotplug NEEDS_RESOURCES testaudiohotplug.c testutils.c)
add_sdl_test_executable(testaudiocapture testaudiocapture.c)
add_sdl_test_executable(testatomic NONINTERACTIVE testatomic.c)
add_sdl_test_executable(testintersections testintersections.c)
add_sdl_test_executable(testrelative testrelative.c)
add_sdl_test_executable(testhittesting testhittesting.c)
add_sdl_test_executable(testdraw2 testdraw2.c)
add_sdl_test_executable(testdrawchessboard testdrawchessboard.c)
add_sdl_test_executable(testdropfile testdropfile.c)
add_sdl_test_executable(testerror NONINTERACTIVE testerror.c)

if(LINUX)
    add_sdl_test_executable(testevdev NONINTERACTIVE testevdev.c)
endif()

add_sdl_test_executable(testfile testfile.c)
add_sdl_test_executable(testgamecontroller NEEDS_RESOURCES testgamecontroller.c testutils.c)
add_sdl_test_executable(testgeometry testgeometry.c testutils.c)
add_sdl_test_executable(testgesture testgesture.c)
add_sdl_test_executable(testgl2 testgl2.c)
add_sdl_test_executable(testgles testgles.c)
add_sdl_test_executable(testgles2 testgles2.c)
add_sdl_test_executable(testgles2_sdf NEEDS_RESOURCES testgles2_sdf.c testutils.c)
add_sdl_test_executable(testhaptic testhaptic.c)
add_sdl_test_executable(testhotplug testhotplug.c)
add_sdl_test_executable(testrumble testrumble.c)
add_sdl_test_executable(testthread NONINTERACTIVE testthread.c)
add_sdl_test_executable(testiconv NEEDS_RESOURCES testiconv.c testutils.c)
add_sdl_test_executable(testime NEEDS_RESOURCES testime.c testutils.c)
add_sdl_test_executable(testjoystick testjoystick.c)
add_sdl_test_executable(testkeys testkeys.c)
add_sdl_test_executable(testloadso testloadso.c)
add_sdl_test_executable(testlocale NONINTERACTIVE testlocale.c)
add_sdl_test_executable(testlock testlock.c)
add_sdl_test_executable(testmouse testmouse.c)

if(APPLE)
    add_sdl_test_executable(testnative NEEDS_RESOURCES
        testnative.c
        testnativecocoa.m
        testnativex11.c
        testutils.c
    )

    cmake_push_check_state(RESET)
    check_c_compiler_flag(-Wno-error=deprecated-declarations HAVE_WNO_ERROR_DEPRECATED_DECLARATIONS)
    cmake_pop_check_state()
    if(HAVE_WNO_ERROR_DEPRECATED_DECLARATIONS)
        set_property(SOURCE "testnativecocoa.m" APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-error=deprecated-declarations")
    endif()
elseif(WINDOWS)
    add_sdl_test_executable(testnative NEEDS_RESOURCES testnative.c testnativew32.c testutils.c)
elseif(HAVE_X11)
    add_sdl_test_executable(testnative NEEDS_RESOURCES testnative.c testnativex11.c testutils.c)
    target_link_libraries(testnative X11)
elseif(OS2)
    add_sdl_test_executable(testnative NEEDS_RESOURCES testnative.c testnativeos2.c testutils.c)
endif()

add_sdl_test_executable(testoverlay2 NEEDS_RESOURCES testoverlay2.c testyuv_cvt.c testutils.c)
add_sdl_test_executable(testplatform NONINTERACTIVE testplatform.c)
add_sdl_test_executable(testpower NONINTERACTIVE testpower.c)
add_sdl_test_executable(testfilesystem NONINTERACTIVE testfilesystem.c)
add_sdl_test_executable(testrendertarget NEEDS_RESOURCES testrendertarget.c testutils.c)
add_sdl_test_executable(testscale NEEDS_RESOURCES testscale.c testutils.c)
add_sdl_test_executable(testsem testsem.c)
add_sdl_test_executable(testsensor testsensor.c)
add_sdl_test_executable(testshader NEEDS_RESOURCES testshader.c)
add_sdl_test_executable(testshape NEEDS_RESOURCES testshape.c)
add_sdl_test_executable(testsprite2 NEEDS_RESOURCES testsprite2.c testutils.c)
add_sdl_test_executable(testspriteminimal NEEDS_RESOURCES testspriteminimal.c testutils.c)
add_sdl_test_executable(teststreaming NEEDS_RESOURCES teststreaming.c testutils.c)
add_sdl_test_executable(testtimer NONINTERACTIVE testtimer.c)
add_sdl_test_executable(testurl testurl.c)
add_sdl_test_executable(testver NONINTERACTIVE testver.c)
add_sdl_test_executable(testviewport NEEDS_RESOURCES testviewport.c testutils.c)
add_sdl_test_executable(testwm2 testwm2.c)
add_sdl_test_executable(testyuv NEEDS_RESOURCES testyuv.c testyuv_cvt.c)
add_sdl_test_executable(torturethread torturethread.c)
add_sdl_test_executable(testrendercopyex NEEDS_RESOURCES testrendercopyex.c testutils.c)
add_sdl_test_executable(testmessage testmessage.c)
add_sdl_test_executable(testdisplayinfo testdisplayinfo.c)
add_sdl_test_executable(testqsort NONINTERACTIVE testqsort.c)
add_sdl_test_executable(testbounds testbounds.c)
add_sdl_test_executable(testcustomcursor testcustomcursor.c)
add_sdl_test_executable(controllermap NEEDS_RESOURCES controllermap.c testutils.c)
add_sdl_test_executable(testvulkan testvulkan.c)
add_sdl_test_executable(testoffscreen testoffscreen.c)

cmake_push_check_state(RESET)

check_c_compiler_flag(-Wformat-overflow HAVE_WFORMAT_OVERFLOW)
if(HAVE_WFORMAT_OVERFLOW)
    target_compile_definitions(testautomation PRIVATE HAVE_WFORMAT_OVERFLOW)
endif()

check_c_compiler_flag(-Wformat HAVE_WFORMAT)
if(HAVE_WFORMAT)
    target_compile_definitions(testautomation PRIVATE HAVE_WFORMAT)
endif()

check_c_compiler_flag(-Wformat-extra-args HAVE_WFORMAT_EXTRA_ARGS)
if(HAVE_WFORMAT_EXTRA_ARGS)
    target_compile_definitions(testautomation PRIVATE HAVE_WFORMAT_EXTRA_ARGS)
endif()

cmake_pop_check_state()

if(SDL_DUMMYAUDIO)
  list(APPEND SDL_TESTS_NONINTERACTIVE
    testaudioinfo
    testsurround
  )
endif()

if(SDL_DUMMYVIDEO)
  list(APPEND SDL_TESTS_NONINTERACTIVE
    testkeys
    testbounds
    testdisplayinfo
  )
endif()

if(OPENGL_FOUND)
    if(TARGET OpenGL::GL)
        target_link_libraries(testshader OpenGL::GL)
        target_link_libraries(testgl2 OpenGL::GL)
    else()
        if(EMSCRIPTEN AND OPENGL_gl_LIBRARY STREQUAL "nul")
            set(OPENGL_gl_LIBRARY GL)
        endif()
        # emscripten's FindOpenGL.cmake does not create OpenGL::GL
        target_link_libraries(testshader ${OPENGL_gl_LIBRARY})
        target_link_libraries(testgl2 ${OPENGL_gl_LIBRARY})
    endif()
endif()
if(EMSCRIPTEN)
    target_link_libraries(testshader -sLEGACY_GL_EMULATION)
endif()

file(GLOB RESOURCE_FILES *.bmp *.wav *.hex moose.dat utf8.txt)
file(COPY ${RESOURCE_FILES} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

if(PSP)
    # Build EBOOT files if building for PSP
    set(BUILD_EBOOT
        ${SDL_TESTS_NEEDS_ESOURCES}
        testatomic
        testaudiocapture
        testaudioinfo
        testbounds
        testdisplayinfo
        testdraw2
        testdrawchessboard
        testerror
        testfile
        testfilesystem
        testgeometry
        testgl2
        testhittesting
        testiconv
        testintersections
        testjoystick
        testlock
        testmessage
        testoverlay2
        testplatform
        testpower
        testqsort
        testsem
        teststreaming
        testsurround
        testthread
        testtimer
        testver
        testviewport
        testwm2
        torturethread
    )
    foreach(APP IN LISTS BUILD_EBOOT)
        create_pbp_file(
            TARGET          ${APP}
            TITLE           SDL-${APP}
            ICON_PATH       NULL
            BACKGROUND_PATH NULL
            PREVIEW_PATH    NULL
        )
        add_custom_command(
            TARGET ${APP} POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E make_directory
            $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}
        )
        add_custom_command(
            TARGET ${APP} POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E rename
            $<TARGET_FILE_DIR:${ARG_TARGET}>/EBOOT.PBP
            $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}/EBOOT.PBP
        )
        if(${BUILD_PRX})
            add_custom_command(
                TARGET ${APP} POST_BUILD
                COMMAND ${CMAKE_COMMAND} -E copy
                $<TARGET_FILE_DIR:${ARG_TARGET}>/${APP}
                $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}/${APP}
            )
            add_custom_command(
                TARGET ${APP} POST_BUILD
                COMMAND ${CMAKE_COMMAND} -E rename
                $<TARGET_FILE_DIR:${ARG_TARGET}>/${APP}.prx
                $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}/${APP}.prx
            )
        endif()
        add_custom_command(
            TARGET ${APP} POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E remove
            $<TARGET_FILE_DIR:${ARG_TARGET}>/PARAM.SFO
        )
    endforeach()
endif()

if(N3DS)
    set(ROMFS_DIR "${CMAKE_CURRENT_BINARY_DIR}/romfs")
    file(COPY ${RESOURCE_FILES} DESTINATION "${ROMFS_DIR}")

    foreach(APP IN LISTS SDL_TEST_EXECUTABLES)
        get_target_property(TARGET_BINARY_DIR ${APP} BINARY_DIR)
        set(SMDH_FILE "${TARGET_BINARY_DIR}/${APP}.smdh")
        ctr_generate_smdh("${SMDH_FILE}"
            NAME "SDL-${APP}"
            DESCRIPTION "SDL2 Test suite"
            AUTHOR "SDL2 Contributors"
            ICON "${CMAKE_CURRENT_SOURCE_DIR}/n3ds/logo48x48.png"
        )
        ctr_create_3dsx(
            ${APP}
            ROMFS "${ROMFS_DIR}"
            SMDH "${SMDH_FILE}"
        )
    endforeach()
endif()

if(RISCOS)
    set(SDL_TEST_EXECUTABLES_AIF)
    foreach(APP IN LISTS SDL_TEST_EXECUTABLES)
        target_link_options(${APP} PRIVATE -static)
        add_custom_command(

=== debian/changelog ===
libsdl2 (2.28.2+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Avoid crashing if all Wayland displays have been disconnected
    - Add game controller mapping for the Steam Deck's built-in gamepad,
      including its back paddles
    - Fix duplicated gamepad mapping for left HVC gamepads
    - Fall back to plain Xlib if Xrandr isn't available, fixing video
      initialization when using VNC
    - Wait a shorter time for X11 window maximization
    - Improve handling of Bluetooth PS4 and PS5 controllers in raw HID mode
    - Don't call an unimplemented fcitx method
    - Better handling of virtual keyboards
    - Reject negative sizes in SDL_RWFromMem(), SDL_RWFromConstMem()
    - Remove unused C++ Vulkan headers
    - Cope with 32-bit ARM platforms where __ARM_ARCH might not be defined
    - Windows-, macOS- and OS/2-specific fixes not relevant to Debian
    - CMake-specific fixes not relevant to Debian
  * Add selected patches from upstream release-2.28.x branch
    - d/p/Removed-Flydigi-Vader-2-mappings.patch,
      d/p/The-Flydigi-Vader-and-Apex-series-controllers-all-have-th.patch:
      Remove problematic gamepad mappings for devices that reuse a name,
      vendor ID and product ID, and therefore cannot be distinguished
      programmatically
    - d/p/Added-a-gamepad-mapping-for-the-G-Shark-GS-GP702.patch:
      Add another gamepad mapping
  * d/p/video-wayland-use-both-icon-and-icon-name-for-Zenity-7897.patch,
    d/p/Fixed-mapping-BTN_TR2-to-right-trigger.patch,
    d/p/Re-added-mappings-for-older-Xbox-One-controllers-on-Linux.patch:
    Drop patches, applied upstream
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Mon, 07 Aug 2023 19:05:51 +0100

libsdl2 (2.28.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Add selected patches from upstream release-2.28.x branch
    - d/p/video-wayland-use-both-icon-and-icon-name-for-Zenity-7897.patch:
      Provide forward-compatibility with zenity >= 3.90.x under Wayland
    - d/p/Fixed-mapping-BTN_TR2-to-right-trigger.patch:
      Fix mapping regression in 2.27.1 for some game controllers with a
      digital right trigger button
    - d/p/Re-added-mappings-for-older-Xbox-One-controllers-on-Linux.patch:
      Fix mapping regression in 2.27.1 for Xbox One controllers (and
      their clones) that report BTN_C and BTN_Z

 -- Simon McVittie <smcv@debian.org>  Mon, 10 Jul 2023 15:22:01 +0100

libsdl2 (2.28.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * d/gbp.conf: Use upstream/2.28.x branch
  * Release to unstable

 -- Simon McVittie <smcv@debian.org>  Tue, 20 Jun 2023 20:36:06 +0100

libsdl2 (2.27.1+dfsg-1) experimental; urgency=medium

  * New upstream prerelease 2.27.1
  * d/libsdl2-2.0-0.symbols: Update

 -- Simon McVittie <smcv@debian.org>  Wed, 14 Jun 2023 15:36:11 +0100

libsdl2 (2.27~git20230406+dfsg-1) experimental; urgency=medium

  * New upstream snapshot release-2.26.0-353-g7ec9a4385

 -- Simon McVittie <smcv@debian.org>  Wed, 12 Apr 2023 10:42:17 +0100

libsdl2 (2.27~git20230308+dfsg-1) experimental; urgency=medium

  * New upstream snapshot release-2.26.0-275-gf5c0760c6

 -- Simon McVittie <smcv@debian.org>  Wed, 08 Mar 2023 12:04:47 +0000

libsdl2 (2.27~git20230216+dfsg-1) experimental; urgency=medium

  * New upstream snapshot release-2.26.0-219-gd948e6c3c

 -- Simon McVittie <smcv@debian.org>  Thu, 16 Feb 2023 12:27:12 +0000

libsdl2 (2.27~git20230207+dfsg-1) experimental; urgency=medium

  * New upstream snapshot release-2.26.0-199-gfde632366
  * d/copyright: Update
  * Build-depend on a new enough libdecor-0-dev.
    The upstream git branch for 0.2.x made some previously private functions
    officially public, and SDL wants to call them.
  * Standards-Version: 4.6.2 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Wed, 08 Feb 2023 21:56:35 +0000

libsdl2 (2.27~git20230103+dfsg-1) experimental; urgency=medium

  * d/control, d/gbp.conf: Start a new branch for snapshot builds
  * New upstream snapshot
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Wed, 04 Jan 2023 17:14:21 +0000

## libsdl2 2.28.3+dfsg

=== debian/changelog ===
libsdl2 (2.28.3+dfsg-2) unstable; urgency=medium

  * Update to upstream release-2.28.x branch commit
    release-2.28.3-5-gd710e0be2, excluding one MSVC-specific change
    - d/p/Detect-Logitech-PRO-Racing-Wheel-for-Xbox-PC-mode-as-whee.patch,
      d/p/Detect-Logitech-G923-Playstation-as-wheel.patch,
      d/p/Detect-Simagic-wheel-bases-as-wheels-8198.patch:
      Update table of known driving-simulation steering wheel controllers
    - d/p/render-Enable-clipping-for-zero-sized-rectangles.patch:
      Fix a UI regression since 2.27.x in Battle for Wesnoth 1.17.x
      and other games that rely on being able to disable UI elements
      by setting a clipping rectangle with zero width or height
      (Closes: #1051522)

 -- Simon McVittie <smcv@debian.org>  Sun, 10 Sep 2023 14:13:16 +0100

libsdl2 (2.28.3+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Implement SDL_TriggerBreakpoint() on riscv64
    - Silence "ioctl (GFEATURE)" warnings on stderr when using raw HID
    - Fix report format for Razer Wolverine V2 Pro
    - Fix a (harmless?) out-of-bounds read when guessing whether game
      controller axes are a digital hat-switch (regression in 2.23.1)
    - Remaining changes are not relevant on architectures supported
      by Debian
  * d/p/Removed-Flydigi-Vader-2-mappings.patch,
    d/p/The-Flydigi-Vader-and-Apex-series-controllers-all-have-th.patch,
    d/p/Added-a-gamepad-mapping-for-the-G-Shark-GS-GP702.patch:
    Drop patches, applied upstream

 -- Simon McVittie <smcv@debian.org>  Fri, 01 Sep 2023 20:23:54 +0100

## libsdl2 2.28.5+dfsg

=== debian/changelog ===
libsdl2 (2.28.5+dfsg-3) unstable; urgency=medium

  * d/patches: Add post-release bug fixes from upstream
    - Improved game controller hardware support:
      + add mapping for Atari VCS via Bluetooth
      + 8BitDo Ultimate Wired Controller for Xbox has a Share button
      + 8BitDo Ultimate Wireless / Pro 2 Wired Controller for Xbox
        has a Share button
    - Update list of mice that should not be treated as game controllers
      + add ROG Pugio II
    - Avoid leaking a window surface when using software rendering
    - Avoid leaking desktop display mode information in some cases
      (probably only Windows but could in principle affect Linux)
    - Don't truncate non-ASCII X11 input
    - Silence a compiler warning
    This brings us up to release-2.28.x branch commit
    release-2.28.5-18-g05eb08053, excluding CMake-, iOS- and
    Windows-specific changes.
  * d/p/sdl2.m4-Call-PKG_CONFIG-rather-than-hard-coding-pkg-confi.patch:
    Add patch from upstream git to make AM_PATH_SDL2 set $SDL_CONFIG to a
    cross-compile-friendly value, related to #1059749.
    Thanks to Helmut Grohne

 -- Simon McVittie <smcv@debian.org>  Tue, 02 Jan 2024 15:23:46 +0000

libsdl2 (2.28.5+dfsg-2) unstable; urgency=medium

  * d/p/configure-move-HAVE_LINUX_INPUT_H-to-CheckInputEvents.patch,
    Revert patch which breaks Linux joystick/gamepad detection.
    See upstream issue SDL#8488.

 -- Simon McVittie <smcv@debian.org>  Mon, 06 Nov 2023 19:41:49 +0000

libsdl2 (2.28.5+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Don't read destination pixels if they will be fully overwritten
    - Remove workaround for a fixed libdecor bug
    - Fix a crash when trying to use XInput2 if libxi was missing
    - Don't try to destroy a NULL relative pointer handle on Wayland
      implementations that don't support that feature
    - Improve precondition checks for Wayland pointer confinement
    - Check whether HIDAPI joysticks were unplugged during detection
    - Detect HP HyperX Clutch Gladiate as an Xbox-One-compatible controller
    - Detect several Asetek Wheelbase models as steering wheels
    - Test improvements
    - Android, CI, CMake and Windows changes that are not relevant to how
      Debian compiles this library
  * d/p/configure-move-HAVE_LINUX_INPUT_H-to-CheckInputEvents.patch,
    d/p/fix-a-possible-memory-leak-in-SDL_vasprintf.patch:
    Add post-release bug fixes from upstream:
    - Improve detection of <linux/input.h>
    - Fix a memory leak on vsnprintf() error in SDL_vasprintf()
    This brings us up to release-2.28.x branch commit
    release-2.28.5-4-g9b2c70c9c, excluding CMake and Windows changes.

 -- Simon McVittie <smcv@debian.org>  Mon, 06 Nov 2023 10:34:27 +0000

libsdl2 (2.28.4+dfsg-1) unstable; urgency=medium

  * New upstream stable release
    - Optionally use posix_spawnp() in preference to vfork() for xdg-open
    - Fix SDLTest surface comparison on big-endian architectures
    - CMake, Emscripten, QNX and Windows changes that are not relevant to
      how Debian compiles this library
  * Drop patches that came from upstream

 -- Simon McVittie <smcv@debian.org>  Mon, 02 Oct 2023 10:21:52 +0100

libsdl2 (2.28.3+dfsg-4) unstable; urgency=medium

  * Update to upstream release-2.28.x branch commit
    release-2.28.3-18-gd58fa94ee, excluding emscripten-specific changes
    and changes in files that are replaced by dh_autoreconf.
    - d/p/Fixed-sensor-timestamp-calculation-for-third-party-PS5-co.patch,
      d/p/Fixed-error-array-subscript-2-is-above-array-bounds-of-co.patch,
      d/p/Fixed-sensor-timestamp-units-for-third-party-PS5-controll.patch:
      Improve handling of third-party PS5-compatible gamepads
    - d/p/Check-for-NULL-before-dereferencing-newly-allocated-memor.patch,
      d/p/SDL_iconv_string-defaults-to-UTF-8.patch:
      Move NULL checks before dereferencing the potentially-null pointer

 -- Simon McVittie <smcv@debian.org>  Thu, 28 Sep 2023 10:51:18 +0100

libsdl2 (2.28.3+dfsg-3) unstable; urgency=medium

  * d/patches: Update to upstream release-2.28.x branch commit
    release-2.28.3-10-g7d80e2088, excluding changes that are not relevant
    to the way Debian builds libsdl2
    - d/p/detect-fanatec-steering-wheels.patch: Detect more steering wheels
    - d/p/x11-Always-update-clipboard-owner.patch: Let clipboard managers
      keep track of clipboard changes
  * d/p/no-libdir.patch: If $CC doesn't support -print-multiarch, assume
    static linking is native.
    As documented by upstream in docs/README-dynapi.md, statically linking
    SDL is not recommended. Please link to SDL dynamically if possible.
    However, the legacy sdl2-config script historically supported static
    linking, so we have to keep that working while not breaking multiarch
    co-installation.
    clang-16 no longer supports the -print-multiarch option, which we
    previously relied on here. Fall back to assuming that we're doing a
    native build (more precisely, a build whose host architecture matches
    the pkg-config in the $PATH) rather than failing to link statically
    at all. (Closes: #1051946)
    It is unavoidable that this will not work if you are cross-compiling
    with a compiler that does not support the -print-multiarch option,
    and also linking statically, and also do not have the PKG_CONFIG or
    DEB_HOST_MULTIARCH environment variables set. In this situation,
    please set PKG_CONFIG and/or DEB_HOST_MULTIARCH (preferably both)
    to their appropriate values.

 -- Simon McVittie <smcv@debian.org>  Mon, 18 Sep 2023 13:55:17 +0100

## libsdl2 2.30.0%2Bdfsg

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.0...3.5)
 project(SDL2_test)
 
 include(CheckCCompilerFlag)
@@ -7,18 +7,55 @@
 
 set(SDL_TEST_EXECUTABLES)
 set(SDL_TESTS_NONINTERACTIVE)
-set(SDL_TESTS_NEEDS_ESOURCES)
+set(SDL_TESTS_NEEDS_RESOURCES)
 
 macro(add_sdl_test_executable TARGET)
     cmake_parse_arguments(AST "NONINTERACTIVE;NEEDS_RESOURCES" "" "" ${ARGN})
-    add_executable(${TARGET} ${AST_UNPARSED_ARGUMENTS})
+    if(ANDROID)
+        add_library(${TARGET} SHARED ${AST_UNPARSED_ARGUMENTS})
+    else()
+        add_executable(${TARGET} ${AST_UNPARSED_ARGUMENTS})
+    endif()
 
     list(APPEND SDL_TEST_EXECUTABLES ${TARGET})
     if(AST_NONINTERACTIVE)
         list(APPEND SDL_TESTS_NONINTERACTIVE ${TARGET})
     endif()
     if(AST_NEEDS_RESOURCES)
-        list(APPEND SDL_TESTS_NEEDS_ESOURCES ${TARGET})
+        list(APPEND SDL_TESTS_NEEDS_RESOURCES ${TARGET})
+    endif()
+
+    if(HAVE_GCC_WDOCUMENTATION)
+        target_compile_options(${TARGET} PRIVATE "-Wdocumentation")
+        if(HAVE_GCC_WERROR_DOCUMENTATION)
+            target_compile_options(${TARGET} PRIVATE "-Werror=documentation")
+        endif()
+    endif()
+
+    if(HAVE_GCC_WDOCUMENTATION_UNKNOWN_COMMAND)
+        if(SDL_WERROR)
+            if(HAVE_GCC_WERROR_DOCUMENTATION_UNKNOWN_COMMAND)
+                target_compile_options(${TARGET} PRIVATE "-Werror=documentation-unknown-command")
+            endif()
+        endif()
+        target_compile_options(${TARGET} PRIVATE "-Wdocumentation-unknown-command")
+    endif()
+
+    if(HAVE_GCC_COMMENT_BLOCK_COMMANDS)
+        target_compile_options(${TARGET} PRIVATE "-fcomment-block-commands=threadsafety")
+        target_compile_options(${TARGET} PRIVATE "-fcomment-block-commands=deprecated")
+    else()
+        if(HAVE_CLANG_COMMENT_BLOCK_COMMANDS)
+            target_compile_options(${TARGET} PRIVATE "/clang:-fcomment-block-commands=threadsafety")
+            target_compile_options(${TARGET} PRIVATE "/clang:-fcomment-block-commands=deprecated")
+        endif()
+    endif()
+
+    if(USE_GCC OR USE_CLANG)
+        check_c_compiler_flag(-fno-fast-math HAVE_GCC_FNO_FAST_MATH)
+        if(HAVE_GCC_FNO_FAST_MATH)
+            target_compile_options(${TARGET} PRIVATE -fno-fast-math)
+        endif()
     endif()
 endmacro()
 
@@ -53,7 +90,7 @@
         psppower
     )
 elseif(PS2)
-link_libraries(
+    link_libraries(
         SDL2main
         SDL2_test
         SDL2-static
@@ -61,7 +98,7 @@
         gskit
         dmakit
         ps2_drivers
-)
+    )
 else()
     link_libraries(SDL2::SDL2test SDL2::SDL2-static)
 endif()
@@ -91,7 +128,7 @@
 endif()
 
 if (OPENGL_FOUND)
-add_definitions(-DHAVE_OPENGL)
+    add_definitions(-DHAVE_OPENGL)
 endif()
 
 add_sdl_test_executable(checkkeys checkkeys.c)
@@ -103,7 +140,7 @@
 add_sdl_test_executable(testaudioinfo testaudioinfo.c)
 
 file(GLOB TESTAUTOMATION_SOURCE_FILES testautomation*.c)
-add_sdl_test_executable(testautomation NEEDS_RESOURCES ${TESTAUTOMATION_SOURCE_FILES})
+add_sdl_test_executable(testautomation NONINTERACTIVE NEEDS_RESOURCES ${TESTAUTOMATION_SOURCE_FILES})
 add_sdl_test_executable(testmultiaudio NEEDS_RESOURCES testmultiaudio.c testutils.c)
 add_sdl_test_executable(testaudiohotplug NEEDS_RESOURCES testaudiohotplug.c testutils.c)
 add_sdl_test_executable(testaudiocapture testaudiocapture.c)
@@ -168,6 +205,9 @@
 add_sdl_test_executable(testplatform NONINTERACTIVE testplatform.c)
 add_sdl_test_executable(testpower NONINTERACTIVE testpower.c)
 add_sdl_test_executable(testfilesystem NONINTERACTIVE testfilesystem.c)
+if(WIN32 AND CMAKE_SIZEOF_VOID_P EQUAL 4)
+    add_sdl_test_executable(testfilesystem_pre NONINTERACTIVE testfilesystem_pre.c)
+endif()
 add_sdl_test_executable(testrendertarget NEEDS_RESOURCES testrendertarget.c testutils.c)
 add_sdl_test_executable(testscale NEEDS_RESOURCES testscale.c testutils.c)
 add_sdl_test_executable(testsem testsem.c)
@@ -214,18 +254,18 @@
 cmake_pop_check_state()
 
 if(SDL_DUMMYAUDIO)
-  list(APPEND SDL_TESTS_NONINTERACTIVE
-    testaudioinfo
-    testsurround
-  )
+    list(APPEND SDL_TESTS_NONINTERACTIVE
+        testaudioinfo
+        testsurround
+    )
 endif()
 
 if(SDL_DUMMYVIDEO)
-  list(APPEND SDL_TESTS_NONINTERACTIVE
-    testkeys
-    testbounds
-    testdisplayinfo
-  )
+    list(APPEND SDL_TESTS_NONINTERACTIVE
+        testkeys
+        testbounds
+        testdisplayinfo
+    )
 endif()
 
 if(OPENGL_FOUND)
@@ -251,7 +291,7 @@
 if(PSP)
     # Build EBOOT files if building for PSP
     set(BUILD_EBOOT
-        ${SDL_TESTS_NEEDS_ESOURCES}
+        ${SDL_TESTS_NEEDS_RESOURCES}
         testatomic
         testaudiocapture
         testaudioinfo
@@ -301,53 +341,3 @@
             TARGET ${APP} POST_BUILD
             COMMAND ${CMAKE_COMMAND} -E rename
             $<TARGET_FILE_DIR:${ARG_TARGET}>/EBOOT.PBP
-            $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}/EBOOT.PBP
-        )
-        if(${BUILD_PRX})
-            add_custom_command(
-                TARGET ${APP} POST_BUILD
-                COMMAND ${CMAKE_COMMAND} -E copy
-                $<TARGET_FILE_DIR:${ARG_TARGET}>/${APP}
-                $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}/${APP}
-            )
-            add_custom_command(
-                TARGET ${APP} POST_BUILD
-                COMMAND ${CMAKE_COMMAND} -E rename
-                $<TARGET_FILE_DIR:${ARG_TARGET}>/${APP}.prx
-                $<TARGET_FILE_DIR:${ARG_TARGET}>/sdl-${APP}/${APP}.prx
-            )
-        endif()
-        add_custom_command(
-            TARGET ${APP} POST_BUILD
-            COMMAND ${CMAKE_COMMAND} -E remove
-            $<TARGET_FILE_DIR:${ARG_TARGET}>/PARAM.SFO
-        )
-    endforeach()
-endif()
-
-if(N3DS)
-    set(ROMFS_DIR "${CMAKE_CURRENT_BINARY_DIR}/romfs")
-    file(COPY ${RESOURCE_FILES} DESTINATION "${ROMFS_DIR}")
-
-    foreach(APP IN LISTS SDL_TEST_EXECUTABLES)
-        get_target_property(TARGET_BINARY_DIR ${APP} BINARY_DIR)
-        set(SMDH_FILE "${TARGET_BINARY_DIR}/${APP}.smdh")
-        ctr_generate_smdh("${SMDH_FILE}"
-            NAME "SDL-${APP}"
-            DESCRIPTION "SDL2 Test suite"
-            AUTHOR "SDL2 Contributors"
-            ICON "${CMAKE_CURRENT_SOURCE_DIR}/n3ds/logo48x48.png"
-        )
-        ctr_create_3dsx(
-            ${APP}
-            ROMFS "${ROMFS_DIR}"
-            SMDH "${SMDH_FILE}"
-        )
-    endforeach()
-endif()
-
-if(RISCOS)
-    set(SDL_TEST_EXECUTABLES_AIF)
-    foreach(APP IN LISTS SDL_TEST_EXECUTABLES)
-        target_link_options(${APP} PRIVATE -static)
-        add_custom_command(

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

built_binaries := $(shell dh_listpackages)

include /usr/share/dpkg/default.mk

confflags = \
	--disable-alsa-shared \
	--disable-arts \
	--disable-directx \
	--disable-esd \
	--disable-fusionsound \
	--disable-jack \
	--disable-joystick-mfi \
	--disable-kmsdrm-shared \
	--disable-libsamplerate-shared \
	--disable-nas \
	--disable-pulseaudio-shared \
	--disable-render-d3d \
	--disable-rpath \
	--disable-video-cocoa \
	--disable-video-directfb \
	--disable-video-metal \
	--disable-video-opengles1 \
	--disable-video-rpi \
	--disable-video-vivante \
	--disable-wasapi \
	--disable-wayland-shared \
	--disable-x11-shared \
	--disable-xinput \
	--enable-alsa \
	--enable-dbus \
	--enable-fcitx \
	--enable-hidapi \
	--enable-hidapi-joystick \
	--enable-ibus \
	--enable-libsamplerate \
	--enable-pulseaudio \
	--enable-sdl2-config \
	--enable-sndio \
	--enable-vendor-info="${DEB_VENDOR} ${DEB_VERSION}" \
	--enable-video-kmsdrm \
	--enable-video-opengl \
	--enable-video-opengles \
	--enable-video-opengles2 \
	--enable-video-x11 \
	$(NULL)

# disable autoheader (invoked automatically by autoreconf), necessary in order
# to use debhelper compat level v10 without overriding dh-autoreconf calls
export AUTOHEADER := /bin/true


ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
  confflags += --disable-altivec
endif

ifeq ($(DEB_HOST_ARCH_CPU),ppc64el)
  confflags += --disable-altivec
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  confflags += --enable-libdecor
  confflags += --enable-libudev
  confflags += --enable-pipewire
  confflags += --enable-video-vulkan
  confflags += --enable-video-wayland
else
  confflags += --disable-libdecor
  confflags += --disable-libudev
  confflags += --disable-pipewire
  confflags += --disable-video-vulkan
  confflags += --disable-video-wayland
endif

# don't use libunwind even if it happens to be installed
confflags += ac_cv_header_libunwind_h=no

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(confflags)
	# test/configure.ac uses AC_PATH_X, so we need to pass in
	# --x-includes and --x-libraries to avoid it wanting to use
	# xmkmf to discover the right values.
	# test/configure.ac doesn't respect CPPFLAGS or LDFLAGS.
	dh_auto_configure \
		--buildsystem=autoconf \
		--sourcedirectory=$(CURDIR)/test \
		--builddirectory=$(CURDIR)/debian/build-tests \
		-- \
		--x-includes=/usr/include \
		--x-libraries=/usr/lib/$(DEB_HOST_MULTIARCH) \
		SDL_CFLAGS=-I$(CURDIR)/include \
		SDL_LIBS="-L$(CURDIR)/build/.libs -lSDL2" \
		ac_cv_lib_SDL2_ttf_TTF_Init=no \
		CFLAGS="$(CPPFLAGS) $(CFLAGS) $(LDFLAGS)" \
		$(NULL)

override_dh_auto_build-indep:
	GZIP="-9n" tar \
		--exclude=autom4te.cache \
		--owner=0 --group=0 --mode=go=rX,u+rw,a-s \
		--clamp-mtime --mtime="@$(SOURCE_DATE_EPOCH)" \
		--sort=name \
		-czf debian/examples.tar.gz test
	sed -e 's/FULL_PATH_NAMES *=.*/FULL_PATH_NAMES = NO/' < docs/doxyfile > debian/Doxyfile
	cd docs && doxygen ../debian/Doxyfile
	# useless files
	find docs/output -name "*.md5" -delete
	find docs/output -type d -empty -delete

# Force examples to be installed in libsdl2-doc, it does not happen with compat
# level v11 despite having the file debian/libsdl2-doc.examples (it gets
# installed as part of libsdl2-dev instead)
override_dh_installexamples-indep:
	dh_installexamples -i --doc-main-package=libsdl2-doc

override_dh_auto_build-arch: build-library build-tests
override_dh_auto_build-indep: build-library
build-library:
	dh_auto_build -- V=1
build-tests:
	dh_auto_build \
		--buildsystem=autoconf \
		--sourcedirectory=$(CURDIR)/test \
		--builddirectory=$(CURDIR)/debian/build-tests \
		-- \
		V=1


override_dh_auto_clean-indep:
	dh_auto_clean
	rm -f debian/Doxyfile
	rm -f debian/examples.tar.gz
	rm -rf docs/output

override_dh_auto_test-arch:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	rm -f debian/tests-failed
	dh_auto_test || touch debian/tests-failed
	LD_LIBRARY_PATH=$(CURDIR)/build/.libs \
	dh_auto_test \
		--buildsystem=autoconf \
		--sourcedirectory=$(CURDIR)/test \
		--builddirectory=$(CURDIR)/debian/build-tests \
		-- \
		V=1 || touch debian/tests-failed
	if [ -e debian/tests-failed ]; then exit 1; fi
endif

override_dh_auto_install-arch:
	dh_auto_install -- V=1
	dh_auto_install \
		--buildsystem=autoconf \
		--sourcedirectory=$(CURDIR)/test \
		--builddirectory=$(CURDIR)/debian/build-tests \
		-- \
		V=1

# debhelper >= 13.4 makes all of /usr/libexec executable, which is not
# quite right for installed-tests
override_dh_fixperms:
	dh_fixperms -Xusr/libexec/installed-tests
ifneq ($(filter %-tests,$(built_binaries)),)
	chmod --recursive --changes a+rX,u+w,og-w debian/libsdl2-tests/usr/libexec/installed-tests
endif

override_dh_install:
	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2
	mv debian/tmp/usr/include/SDL2/SDL_config.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2/_real_SDL_config.h
	ln -s ../../SDL2/SDL_platform.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2/
	ln -s ../../SDL2/begin_code.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2/
	ln -s ../../SDL2/close_code.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/SDL2/
	dh_install

override_dh_link:
	# to address lintian warning
	# W: libsdl2-2.0-0: dev-pkg-without-shlib-symlink usr/lib/x86_64-linux-gnu/libSDL2-2.0.so.0.0.0 usr/lib/x86_64-linux-gnu/libSDL2-2.0.so
	dh_link -plibsdl2-dev usr/lib/$(DEB_HOST_MULTIARCH)/libSDL2-2.0.so.0 usr/lib/$(DEB_HOST_MULTIARCH)/libSDL2-2.0.so
	dh_link --remaining-packages

override_dh_installchangelogs:
	dh_installchangelogs -- WhatsNew.txt
